
-- must have master key in master database
USE master
go

CREATE MASTER KEY ENCRYPTION BY PASSWORD = 'StrongPassword1'
go

CREATE ASYMMETRIC KEY assm FROM FILE='c:\temp\assm.snk'
go

CREATE LOGIN snk FROM ASYMMETRIC KEY assm
go

GRANT UNSAFE ASSEMBLY TO snk
GO

CREATE ASSEMBLY unsafeassemblyex FROM 'c:\temp\unsafeassemblyex.dll'
  WITH permission_set = unsafe
GO

-- Another Way

DROP LOGIN snk 
GO

DROP ASYMMETRIC KEY assm
GO

DROP ASSEMBLY unsafeassemblyex
GO

CREATE ASYMMETRIC KEY assm2 FROM EXECUTABLE FILE='c:\temp\unsafeassemblyex.dll'
go

CREATE LOGIN assm FROM ASYMMETRIC KEY assm2
go

GRANT UNSAFE ASSEMBLY TO assm
GO

CREATE ASSEMBLY unsafeassemblyex FROM 'c:\temp\unsafeassemblyex.dll'
  WITH permission_set = unsafe
GO

DROP LOGIN assm 
GO

DROP ASYMMETRIC KEY assm2
GO

-- Msg 15208, Level 16, State 1, Line 1
-- The certificate, asymmetric key, or private key file does not exist or has invalid format.
CREATE CERTIFICATE mycert FROM ASSEMBLY unsafeassemblyex
GO